require({cache:{
'url:epi-ecf-ui/widget/templates/DictionaryAdministration.html':"﻿<div class=\"epi-view-container epi-view-container--scrollable\">\n    <div class=\"epi-localToolbar\">\n        <div class=\"epi-toolbarGroupContainer\">\n            <h1>${resources.title}</h1>\n            <div class=\"epi-toolbarGroup epi-toolbarTrailing\">\n                <a data-dojo-attach-point=\"helpButtonNode\"></a>\n            </div>\n        </div>\n    </div>\n    <div>\n        <p class=\"epi-help\">${resources.description}</p>\n        <div data-dojo-attach-point=\"gridNode\"></div>\n    </div>\n</div>"}});
﻿define("epi-ecf-ui/widget/DictionaryAdministration", [
    // dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    // dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    // dgrid
    "dgrid/OnDemandGrid",
    "dgrid/Selection",
    // epi
    "epi/dependency",
    "epi/shell/widget/dialog/Dialog",
    "epi/shell/dgrid/util/misc",
    // epi-cms
    "epi-cms/dgrid/formatters",
    // epi-ecf-ui
    "../contentediting/editors/DictionaryEditor",
    "../widget/_HelpMixin",
    // resources
    "dojo/text!./templates/DictionaryAdministration.html",
    "epi/i18n!epi/nls/episerver.shared",
    "epi/i18n!epi/nls/commerce.widget.dictionaryadministration"
], function (
    // dojo
    array,
    declare,
    lang,
    domConstruct,
    // dijit
    _Widget,
    _TemplatedMixin,
    // dgrid
    OnDemandGrid,
    Selection,
    // epi
    dependency,
    Dialog,
    shellMisc,
    // epi-cms
    formatters,
    // epi-ecf-ui
    DictionaryEditor,
    _HelpMixin,
    // resources
    templateString,
    sharedResources,
    resources
) {
    return declare([_Widget, _TemplatedMixin, _HelpMixin], {

        resources: resources,

        templateString: templateString,

        store: null,

        grid: null,

        // _noDataMessage: string
        //      String to notify that the grid content is empty.
        _noDataMessage: '<span><span class="dijitReset dijitInline">' + resources.nodatamessage + '</span></span>',

        postCreate: function () {
            this.inherited(arguments);
            this.store = this.store || dependency.resolve("epi.storeregistry").get("epi.commerce.metadictionary");
            this._setupGrid();
        },

        _setupGrid: function () {
            var gridType = declare([OnDemandGrid, Selection]);
            var columns = this._getColumns();
            this.grid = new gridType({
                selectionMode: "single",
                noDataMessage: this._noDataMessage,
                columns: columns,
                store: this.store,
                className: "epi-plain-grid epi-plain-grid-modal epi-plain-grid--margin-bottom epi-grid-height--auto"
            });
            this.grid.set("query", {});
            this.own(this.grid.on(".dgrid-row:click", lang.hitch(this, function(event){
                this._createAndShowDialog(this.grid.row(event).id);
            })));
            this.own(this.grid);
            domConstruct.place(this.grid.domNode, this.gridNode);
        },

        _getColumns: function(){
            var columns = {
                name: {
                    label:sharedResources.header.name,
                    sortable: false
                },
                items: {
                    label: resources.values,
                    renderCell: function (object, value, node, options) {
                        node.innerHTML = shellMisc.htmlEncode(value.join(', '));
                    },
                    sortable: false
                },
                usingTypes: {
                    label: resources.usedby,
                    renderCell: function (object, value, node, options) {
                        var list = domConstruct.create("ul", null, node);
                        array.forEach(value, function (type) {
                            domConstruct.create("li", { innerHTML : formatters.contentIcon(type.typeIdentifier) + type.name }, list);
                        });
                    },
                    sortable: false
                }
            };
            return columns;
        },

        _createAndShowDialog: function(dictionaryId) {
            if (this._dialog){
                this._dialog.destroy();
                this._dialog = null;
            }
            var dictionaryItemEditor = new DictionaryEditor({dictionaryId: dictionaryId});
            var grid = this.grid;
            this._dialog = new Dialog({
                defaultActionsVisible: false,
                content: dictionaryItemEditor,
                title: resources.values,
                destroyOnHide: true,
                closeIconVisible: false,
                getActions: function() {
                    var done = {
                        name: "done",
                        label: sharedResources.action.done,
                        title: null,
                        settings: {
                            type: "submit",
                            "class": "Salt"
                        }
                    };
                    return [done];
                }
            });
            var refreshGrid = function(){
                grid.refresh();
            };
            this._dialog.own(this._dialog.on("cancel", refreshGrid),
                this._dialog.on("execute", refreshGrid));
            this._dialog.show();
            this.own(this._dialog);
        }

    });
});